## alure 1.0

=== CMakeLists.txt ===
# CMakeLists.txt for ALURE
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)

IF(COMMAND CMAKE_POLICY)
    CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)


INCLUDE(CheckCCompilerFlag)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckIncludeFile)
INCLUDE(CheckIncludeFiles)
INCLUDE(CheckLibraryExists)
INCLUDE(FindPkgConfig)
INCLUDE(UsePkgConfig)

PROJECT(ALURE)

IF(WIN32)
    SET(LIBNAME ALURE32)
ELSE(WIN32)
    SET(LIBNAME alure)
ENDIF(WIN32)

SET(LIB_MAJOR_VERSION "1")
SET(LIB_MINOR_VERSION "0")
SET(LIB_BUILD_VERSION "72")
SET(LIB_VERSION "${LIB_MAJOR_VERSION}.${LIB_MINOR_VERSION}.${LIB_BUILD_VERSION}")
IF(NOT DEFINED LIB_INSTALL_DIR)
    SET(LIB_INSTALL_DIR "lib")
ENDIF(NOT DEFINED LIB_INSTALL_DIR)


INCLUDE_DIRECTORIES(include "${ALURE_BINARY_DIR}")


OPTION(NO_SHARED "Build a static library instead of shared" OFF)

IF(NOT CMAKE_BUILD_TYPE)
    SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
        "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)
IF(NOT DEFINED CMAKE_DEBUG_POSTFIX)
    SET(CMAKE_DEBUG_POSTFIX "" CACHE STRING
        "Library postfix for debug builds. Normally left blank."
        FORCE)
ENDIF(NOT DEFINED CMAKE_DEBUG_POSTFIX)


ADD_DEFINITIONS(-DALURE_BUILD_LIBRARY -DHAVE_CONFIG_H)

IF(MSVC)
    # ???
ELSE(MSVC)
    IF(NOT WIN32)
        CHECK_C_COMPILER_FLAG(-fvisibility=hidden HAVE_GCC_VISIBILITY)
        IF(HAVE_GCC_VISIBILITY)
            ADD_DEFINITIONS(-fvisibility=hidden)
        ENDIF(HAVE_GCC_VISIBILITY)
    ENDIF(NOT WIN32)

    CHECK_C_COMPILER_FLAG(-Wextra HAVE_WEXTRA)
    IF(HAVE_WEXTRA)
        ADD_DEFINITIONS(-Wextra)
    ENDIF(HAVE_WEXTRA)
    ADD_DEFINITIONS(-Wall)
ENDIF(MSVC)


OPTION(DYNLOAD "Enable dynamic run-time loading of libraries" ON)

CHECK_INCLUDE_FILE(windows.h HAVE_WINDOWS_H -D_WIN32_WINNT=0x0500)
IF(NOT HAVE_WINDOWS_H)
    CHECK_FUNCTION_EXISTS(nanosleep HAVE_NANOSLEEP)
    IF(NOT HAVE_NANOSLEEP)
        MESSAGE(FATAL_ERROR "No sleep function found!")
    ENDIF(NOT HAVE_NANOSLEEP)

    IF(DYNLOAD)
        CHECK_INCLUDE_FILE(dlfcn.h HAVE_DLFCN_H)
        IF(HAVE_DLFCN_H)
            CHECK_LIBRARY_EXISTS(dl dlopen "" HAVE_LIBDL)
            IF(HAVE_LIBDL)
                SET(HAS_DLOPEN 1)
                SET(EXTRA_LIBS dl ${EXTRA_LIBS})
            ENDIF(HAVE_LIBDL)
        ENDIF(HAVE_DLFCN_H)
    ENDIF(DYNLOAD)
ELSE(NOT HAVE_WINDOWS_H)
    IF(DYNLOAD)
        SET(HAS_LOADLIBRARY 1)
    ENDIF(DYNLOAD)
ENDIF(NOT HAVE_WINDOWS_H)


OPTION(SNDFILE "SoundFile support (for various formats)" ON)
OPTION(VORBIS  "VorbisFile support (for Ogg Vorbis)"  ON)
OPTION(FLAC    "FLAC support (for FLAC and Ogg FLAC)" ON)

IF(WIN32)
    ADD_DEFINITIONS(-D_WIN32)

    IF(CMAKE_SIZEOF_VOID_P MATCHES "8")
        SET(WIN_TYPE Win64)
        SET(XBITS x64)
    ELSE(CMAKE_SIZEOF_VOID_P MATCHES "8")
        SET(WIN_TYPE Win32)
        SET(XBITS x86)
    ENDIF(CMAKE_SIZEOF_VOID_P MATCHES "8")

    SET(OPENAL_SEARCH_PATHS
        ENV ALSDK_DIR
        ENV MINGDIR
        "C:/Program Files/OpenAL 1.1 SDK"
        "C:/Program Files (x86)/OpenAL 1.1 SDK"
        "E:/Programs/Dev/OpenAL"
        "E:/Program Files (x86)/OpenAL 1.1 SDK" )

    FIND_PATH(OPENAL_INCLUDE_DIR al.h
              PATHS ${OPENAL_SEARCH_PATHS}
              PATH_SUFFIXES include include/AL )
    IF(OPENAL_INCLUDE_DIR)
        INCLUDE_DIRECTORIES(${OPENAL_INCLUDE_DIR})
        FIND_LIBRARY(OPENAL_LIBRARIES OpenAL32
                     PATHS ${OPENAL_SEARCH_PATHS}
                     PATH_SUFFIXES lib libs/${WIN_TYPE} )
    ENDIF(OPENAL_INCLUDE_DIR)

    IF(NOT OPENAL_LIBRARIES)
        MESSAGE(FATAL_ERROR "OpenAL not found!\nPlease try setting the ALSDK_DIR environment variable and try again.")
    ENDIF(NOT OPENAL_LIBRARIES)

    MESSAGE(STATUS "OpenAL include: ${OPENAL_INCLUDE_DIR}")
    MESSAGE(STATUS "OpenAL lib: ${OPENAL_LIBRARIES}")
ELSE(WIN32)
    PKG_CHECK_MODULES(OPENAL openal)
    IF(NOT OPENAL_FOUND)
        IF(APPLE)
            CHECK_INCLUDE_FILE(OpenAL/al.h HAVE_OPENAL_AL_H)
            IF(HAVE_OPENAL_AL_H)
                SET(OPENAL_LIBRARIES "-framework OpenAL")
                SET(HAS_OPENAL 1)
            ENDIF(HAVE_OPENAL_AL_H)
        ELSE(APPLE)
            CHECK_INCLUDE_FILE(AL/al.h HAVE_AL_AL_H)
            IF(HAVE_AL_AL_H)
                CHECK_LIBRARY_EXISTS(openal alcOpenDevice "" HAS_OPENAL)
                IF(HAS_OPENAL)
                    SET(OPENAL_LIBRARIES openal)
                ENDIF(HAS_OPENAL)
            ENDIF(HAVE_AL_AL_H)
        ENDIF(APPLE)
        IF(NOT HAS_OPENAL)
            MESSAGE(FATAL_ERROR "OpenAL not found!")
        ENDIF(NOT HAS_OPENAL)
    ELSE(NOT OPENAL_FOUND)
        INCLUDE_DIRECTORIES(${OPENAL_INCLUDE_DIRS})
        LINK_DIRECTORIES(${OPENAL_LIBRARY_DIRS})
    ENDIF(NOT OPENAL_FOUND)
ENDIF(WIN32)

# SndFile support
IF(SNDFILE)
    PKG_CHECK_MODULES(SNDFILE sndfile)
    IF(NOT SNDFILE_FOUND)
        CHECK_INCLUDE_FILE(sndfile.h HAVE_SNDFILE_H)
        IF(HAVE_SNDFILE_H)
            # Libraries will be loaded dynamicly at runtime if possible; don't
            # link them here
            IF(HAS_DLOPEN OR HAS_LOADLIBRARY)
                SET(HAS_SNDFILE 1)
            ELSE(HAS_DLOPEN OR HAS_LOADLIBRARY)
                CHECK_LIBRARY_EXISTS(sndfile sf_open "" HAS_SNDFILE)
                IF(HAS_SNDFILE)
                    SET(SNDFILE_LIBRARIES "sndfile")
                ENDIF(HAS_SNDFILE)
            ENDIF(HAS_DLOPEN OR HAS_LOADLIBRARY)
        ENDIF(HAVE_SNDFILE_H)
    ELSE(NOT SNDFILE_FOUND)
        SET(HAS_SNDFILE 1)
        INCLUDE_DIRECTORIES(${SNDFILE_INCLUDE_DIRS})
        IF(HAS_DLOPEN OR HAS_LOADLIBRARY)
            SET(SNDFILE_LIBRARIES "")
        ELSE(HAS_DLOPEN OR HAS_LOADLIBRARY)
            LINK_DIRECTORIES(${SNDFILE_LIBRARY_DIRS})
        ENDIF(HAS_DLOPEN OR HAS_LOADLIBRARY)
    ENDIF(NOT SNDFILE_FOUND)
ELSE(SNDFILE)
    SET(SNDFILE_LIBRARIES "")
ENDIF(SNDFILE)

# Vorbis support
IF(VORBIS)
    PKG_CHECK_MODULES(VORBISFILE vorbisfile)
    IF(NOT VORBISFILE_FOUND)
        CHECK_INCLUDE_FILE(vorbis/vorbisfile.h HAVE_VORBIS_VORBISFILE_H)
        IF(HAVE_VORBIS_VORBISFILE_H)
            IF(HAS_DLOPEN OR HAS_LOADLIBRARY)
                SET(HAS_VORBISFILE 1)
            ELSE(HAS_DLOPEN OR HAS_LOADLIBRARY)
                CHECK_LIBRARY_EXISTS(vorbisfile ov_open "" HAS_VORBISFILE)
                IF(HAS_VORBISFILE)
                    SET(VORBISFILE_LIBRARIES "vorbisfile")
                ENDIF(HAS_VORBISFILE)
            ENDIF(HAS_DLOPEN OR HAS_LOADLIBRARY)
        ENDIF(HAVE_VORBIS_VORBISFILE_H)
    ELSE(NOT VORBISFILE_FOUND)
        SET(HAS_VORBISFILE 1)
        INCLUDE_DIRECTORIES(${VORBISFILE_INCLUDE_DIRS})
        IF(HAS_DLOPEN OR HAS_LOADLIBRARY)
            SET(VORBISFILE_LIBRARIES "")
        ELSE(HAS_DLOPEN OR HAS_LOADLIBRARY)
            LINK_DIRECTORIES(${VORBISFILE_LIBRARY_DIRS})
        ENDIF(HAS_DLOPEN OR HAS_LOADLIBRARY)
    ENDIF(NOT VORBISFILE_FOUND)
ELSE(VORBIS)
    SET(VORBISFILE_LIBRARIES "")
ENDIF(VORBIS)

# FLAC support
IF(FLAC)
    PKG_CHECK_MODULES(LIBFLAC flac)
    IF(NOT LIBFLAC_FOUND)
        CHECK_INCLUDE_FILE(FLAC/all.h HAVE_FLAC_ALL_H)
        IF(HAVE_FLAC_ALL_H)
            IF(HAS_DLOPEN OR HAS_LOADLIBRARY)
                SET(HAS_FLAC 1)
            ELSE(HAS_DLOPEN OR HAS_LOADLIBRARY)
                CHECK_LIBRARY_EXISTS(FLAC FLAC__stream_decoder_new "" HAS_FLAC)
                IF(HAS_FLAC)
                    SET(LIBFLAC_LIBRARIES "FLAC")
                ENDIF(HAS_FLAC)
            ENDIF(HAS_DLOPEN OR HAS_LOADLIBRARY)
        ENDIF(HAVE_FLAC_ALL_H)
    ELSE(NOT LIBFLAC)
        SET(HAS_FLAC 1)
        INCLUDE_DIRECTORIES(${LIBFLAC_INCLUDE_DIRS})
        IF(HAS_DLOPEN OR HAS_LOADLIBRARY)
            SET(LIBFLAC_LIBRARIES "")
        ELSE(HAS_DLOPEN OR HAS_LOADLIBRARY)
            LINK_DIRECTORIES(${LIBFLAC_LIBRARY_DIRS})
        ENDIF(HAS_DLOPEN OR HAS_LOADLIBRARY)
    ENDIF(NOT LIBFLAC_FOUND)
ELSE(FLAC)
    SET(LIBFLAC_LIBRARIES "")
ENDIF(FLAC)


# For alure.pc.in
SET(prefix ${CMAKE_INSTALL_PREFIX})
SET(exec_prefix "\${prefix}")
SET(libdir "\${exec_prefix}/${LIB_INSTALL_DIR}")
SET(bindir "\${exec_prefix}/bin")
SET(includedir "\${prefix}/include")
SET(PKG_CONFIG_REQUIRES openal)
SET(PACKAGE_VERSION "${LIB_VERSION}")

# End configuration
CONFIGURE_FILE(
    "${ALURE_SOURCE_DIR}/config.h.in"
    "${ALURE_BINARY_DIR}/config.h")
CONFIGURE_FILE(
    "${ALURE_SOURCE_DIR}/alure.pc.in"
    "${ALURE_BINARY_DIR}/alure.pc"
    @ONLY)


SET(ALURE_OBJS  src/alure.cpp
                src/buffer.cpp
                src/stream.cpp
)

IF(NOT NO_SHARED)
    #build a shared library
    ADD_LIBRARY(${LIBNAME} SHARED ${ALURE_OBJS})
    SET_TARGET_PROPERTIES(${LIBNAME} PROPERTIES VERSION ${LIB_VERSION}
                                                SOVERSION ${LIB_MAJOR_VERSION})
    IF(WIN32)
        SET_TARGET_PROPERTIES(${LIBNAME} PROPERTIES PREFIX "")
    ENDIF(WIN32)
    TARGET_LINK_LIBRARIES(${LIBNAME} ${OPENAL_LIBRARIES} ${SNDFILE_LIBRARIES} ${VORBISFILE_LIBRARIES} ${LIBFLAC_LIBRARIES} ${EXTRA_LIBS})
ELSE(NOT NO_SHARED)
    #build a static library
    ADD_LIBRARY(${LIBNAME} STATIC ${ALURE_OBJS})
    SET_TARGET_PROPERTIES(${LIBNAME} PROPERTIES VERSION ${LIB_VERSION})
ENDIF(NOT NO_SHARED)


ADD_EXECUTABLE(alureplay examples/alureplay.c)
TARGET_LINK_LIBRARIES(alureplay ${LIBNAME} ${OPENAL_LIBRARIES} ${SNDFILE_LIBRARIES} ${VORBISFILE_LIBRARIES} ${LIBFLAC_LIBRARIES} ${EXTRA_LIBS} stdc++)

ADD_EXECUTABLE(alurestream examples/alurestream.c)
TARGET_LINK_LIBRARIES(alurestream ${LIBNAME} ${OPENAL_LIBRARIES} ${SNDFILE_LIBRARIES} ${VORBISFILE_LIBRARIES} ${LIBFLAC_LIBRARIES} ${EXTRA_LIBS} stdc++)


FIND_PROGRAM(NATDOCS_BIN NaturalDocs)
IF(NATDOCS_BIN)
    ADD_CUSTOM_TARGET(docs
                      "${NATDOCS_BIN}" -i "${ALURE_SOURCE_DIR}/src" -o HTML "${ALURE_SOURCE_DIR}/docs/html" -p "${ALURE_SOURCE_DIR}/docs/naturaldocs" -s Default CustomStyle
                      COMMENT "Building NaturalDocs documentation..." VERBATIM)
ELSE(NATDOCS_BIN)
    MESSAGE(STATUS "\nNaturalDocs not found; building documentation is disabled")
ENDIF(NATDOCS_BIN)


#add an install target here
IF(APPLE)
    SET(INCPATH OpenAL)
ELSE(APPLE)
    SET(INCPATH AL)
ENDIF(APPLE)

INSTALL(DIRECTORY "${ALURE_SOURCE_DIR}/docs/html"
        DESTINATION share/doc/alure
)
INSTALL(TARGETS ${LIBNAME}
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION ${LIB_INSTALL_DIR}
        ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
)
INSTALL(FILES include/AL/alure.h
        DESTINATION "include/${INCPATH}"
)
INSTALL(FILES "${ALURE_BINARY_DIR}/alure.pc"
        DESTINATION lib/pkgconfig
)


MESSAGE(STATUS "\n********************** Configured options **********************")
IF(NO_SHARED)
    MESSAGE(STATUS "Building static library")
ELSE(NO_SHARED)
    MESSAGE(STATUS "Building shared library")
ENDIF(NO_SHARED)
MESSAGE(STATUS "")
IF(HAS_DLOPEN OR HAS_LOADLIBRARY)
    MESSAGE(STATUS "Dynamic loading of support libs: enabled")
ELSE(HAS_DLOPEN OR HAS_LOADLIBRARY)
    MESSAGE(STATUS "Dynamic loading of support libs: disabled")
ENDIF(HAS_DLOPEN OR HAS_LOADLIBRARY)
MESSAGE(STATUS "")
IF(HAS_SNDFILE)
    MESSAGE(STATUS "SndFile support: enabled")
ELSE(HAS_SNDFILE)
    MESSAGE(STATUS "SndFile support: disabled")
ENDIF(HAS_SNDFILE)
IF(HAS_VORBISFILE)
    MESSAGE(STATUS "VorbisFile support: enabled")
ELSE(HAS_VORBISFILE)
    MESSAGE(STATUS "VorbisFile support: disabled")
ENDIF(HAS_VORBISFILE)
IF(HAS_FLAC)
    MESSAGE(STATUS "FLAC support: enabled")
ELSE(HAS_FLAC)
    MESSAGE(STATUS "FLAC support: disabled")
ENDIF(HAS_FLAC)
MESSAGE(STATUS "")

## alure 1.2

=== CMakeLists.txt ===
# CMakeLists.txt for ALURE
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)

IF(COMMAND CMAKE_POLICY)
    CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

INCLUDE(CheckCCompilerFlag)
INCLUDE(CheckCSourceCompiles)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckIncludeFile)
INCLUDE(CheckIncludeFiles)
INCLUDE(CheckLibraryExists)
INCLUDE(CheckSharedFunctionExists)
INCLUDE(FindPkgConfig)
INCLUDE(UsePkgConfig)
INCLUDE(CheckFileOffsetBits)

PROJECT(ALURE)

IF(WIN32)
    SET(LIBNAME ALURE32)
ELSE(WIN32)
    SET(LIBNAME alure)
ENDIF(WIN32)

SET(LIB_MAJOR_VERSION "1")
SET(LIB_MINOR_VERSION "2")
SET(LIB_VERSION "${LIB_MAJOR_VERSION}.${LIB_MINOR_VERSION}")


INCLUDE_DIRECTORIES(include "${ALURE_BINARY_DIR}")


OPTION(BUILD_SHARED "Build the shared version of the library" ON)
OPTION(BUILD_STATIC "Build the static version of the library" ON)

IF(NOT BUILD_SHARED AND NOT BUILD_STATIC)
    MESSAGE(FATAL_ERROR "No libtype being built!")
ENDIF(NOT BUILD_SHARED AND NOT BUILD_STATIC)

IF(NOT CMAKE_BUILD_TYPE)
    SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
        "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)
IF(NOT DEFINED CMAKE_DEBUG_POSTFIX)
    SET(CMAKE_DEBUG_POSTFIX "" CACHE STRING
        "Library postfix for debug builds. Normally left blank."
        FORCE)
ENDIF(NOT DEFINED CMAKE_DEBUG_POSTFIX)


CHECK_LIBRARY_EXISTS(stdc++ memset "" HAS_STDCXX)
IF(HAS_STDCXX)
    SET(EXTRA_LIBS stdc++ ${EXTRA_LIBS})
ENDIF(HAS_STDCXX)

CHECK_LIBRARY_EXISTS(m pow "" HAS_LIBM)
IF(HAS_LIBM)
    SET(EXTRA_LIBS m ${EXTRA_LIBS})
ENDIF(HAS_LIBM)

CHECK_FILE_OFFSET_BITS()
IF(_FILE_OFFSET_BITS)
    ADD_DEFINITIONS(-D_FILE_OFFSET_BITS=${_FILE_OFFSET_BITS})
    SET(CMAKE_REQUIRED_DEFINITIONS ${CMAKE_REQUIRED_DEFINITIONS} -D_FILE_OFFSET_BITS=${_FILE_OFFSET_BITS})
ENDIF(_FILE_OFFSET_BITS)

CHECK_FUNCTION_EXISTS(fseeko HAVE_FSEEKO)
IF(NOT HAVE_FSEEKO)
    CHECK_FUNCTION_EXISTS(_fseeki64 HAVE__FSEEKI64)
ENDIF(NOT HAVE_FSEEKO)

SET(STATIC_CFLAGS "${STATIC_CFLAGS} -DALURE_STATIC_LIBRARY")

IF(MSVC)
    # ???
ELSE(MSVC)
    IF(NOT WIN32)
        CHECK_C_SOURCE_COMPILES("int foo() __attribute__((constructor));
                                 int main() {return 0;}" HAVE_GCC_CONSTRUCTOR)

        # Force -fPIC for the static lib, because it causes problems when the
        # static version is linked to a dynamic lib
        SET(STATIC_CFLAGS "${STATIC_CFLAGS} -fPIC")
    ENDIF(NOT WIN32)

    CHECK_C_COMPILER_FLAG(-Wextra HAVE_WEXTRA)
    IF(HAVE_WEXTRA)
        ADD_DEFINITIONS(-Wextra)
    ENDIF(HAVE_WEXTRA)
    ADD_DEFINITIONS(-Wall)

    CHECK_C_COMPILER_FLAG(-funswitch-loops HAVE_FUNSWITCH_LOOPS)
    IF(HAVE_FUNSWITCH_LOOPS)
        ADD_DEFINITIONS(-funswitch-loops)
    ENDIF(HAVE_FUNSWITCH_LOOPS)
ENDIF(MSVC)

# Set visibility/export options if available
SET(EXPORT_DECL "")
IF(WIN32)
    SET(EXPORT_DECL "__declspec(dllexport)")
ELSE(WIN32)
    CHECK_C_COMPILER_FLAG(-fvisibility=hidden HAVE_VISIBILITY_SWITCH)
    CHECK_C_SOURCE_COMPILES("int foo() __attribute__((visibility(\"protected\")));
                             int main() {return 0;}" HAVE_GCC_VISIBILITY)
    IF(HAVE_VISIBILITY_SWITCH AND HAVE_GCC_VISIBILITY)
        ADD_DEFINITIONS(-fvisibility=hidden)
        SET(EXPORT_DECL "__attribute__((visibility(\"protected\")))")
    ENDIF(HAVE_VISIBILITY_SWITCH AND HAVE_GCC_VISIBILITY)
ENDIF(WIN32)


CHECK_INCLUDE_FILE(windows.h HAVE_WINDOWS_H -D_WIN32_WINNT=0x0500)
IF(HAVE_WINDOWS_H)
    CHECK_INCLUDE_FILE(ddk/ntddcdrm.h HAVE_DDK_NTDDCDRM_H)
ELSE(HAVE_WINDOWS_H)
    CHECK_C_COMPILER_FLAG(-pthread HAVE_PTHREAD)
    IF(HAVE_PTHREAD)
        ADD_DEFINITIONS(-pthread)
        SET(EXTRA_LIBS ${EXTRA_LIBS} -pthread)
    ENDIF(HAVE_PTHREAD)

    # We need pthreads outside of Windows
    CHECK_INCLUDE_FILE(pthread.h HAVE_PTHREAD_H)
    IF(NOT HAVE_PTHREAD_H)
        MESSAGE(FATAL_ERROR "PThreads is required for non-Windows builds!")
    ENDIF()
    # Some systems need pthread_np.h to get recursive mutexes
    CHECK_INCLUDE_FILES("pthread.h;pthread_np.h" HAVE_PTHREAD_NP_H)

    # _GNU_SOURCE is needed on some systems for extra attributes, and
    # _REENTRANT is needed for libc thread-safety
    ADD_DEFINITIONS(-D_GNU_SOURCE=1)
    CHECK_FUNCTION_EXISTS(pthread_create HAS_PTHREAD_CREATE)
    IF(NOT HAS_PTHREAD_CREATE)
        CHECK_SHARED_FUNCTION_EXISTS(pthread_create "pthread.h" pthread "" HAVE_LIBPTHREAD)
        IF(NOT HAVE_LIBPTHREAD)
            MESSAGE(FATAL_ERROR "pthread_create not found on non-Windows target!")
        ENDIF(NOT HAVE_LIBPTHREAD)
        SET(EXTRA_LIBS pthread ${EXTRA_LIBS})
    ENDIF(NOT HAS_PTHREAD_CREATE)

    CHECK_FUNCTION_EXISTS(nanosleep HAVE_NANOSLEEP)
    IF(NOT HAVE_NANOSLEEP)
        MESSAGE(FATAL_ERROR "No sleep function found!")
    ENDIF(NOT HAVE_NANOSLEEP)
ENDIF(HAVE_WINDOWS_H)

CHECK_INCLUDE_FILE(sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILE(sys/wait.h HAVE_SYS_WAIT_H)
CHECK_INCLUDE_FILE(signal.h HAVE_SIGNAL_H)
CHECK_INCLUDE_FILE(dlfcn.h HAVE_DLFCN_H)

IF(HAVE_DLFCN_H)
    CHECK_SHARED_FUNCTION_EXISTS(dlopen "dlfcn.h" dl "" HAVE_LIBDL)
    IF(HAVE_LIBDL)
        SET(EXTRA_LIBS dl ${EXTRA_LIBS})
    ENDIF(HAVE_LIBDL)
ENDIF(HAVE_DLFCN_H)

OPTION(DYNLOAD    "Dynamically load support libs at run-time" ON)
OPTION(SNDFILE    "SoundFile support (for various formats)" ON)
OPTION(VORBIS     "VorbisFile support (for Ogg Vorbis)"  ON)
OPTION(FLAC       "FLAC support (for FLAC and Ogg FLAC)" ON)
OPTION(MPG123     "MPG123 support (for MP1/MP2/MP3)" ON)
OPTION(DUMB       "DUMB support (for IT/XM/S3M/MOD)" ON)
OPTION(MODPLUG    "ModPlug support (for IT/XM/S3M/MOD)" OFF)
OPTION(FLUIDSYNTH "FluidSynth support (for MID)" ON)

IF(WIN32)
    ADD_DEFINITIONS(-D_WIN32)
ELSE(WIN32)
    IF(NOT HAVE_DLFCN_H OR NOT HAVE_LIBDL)
        SET(DYNLOAD OFF)
    ENDIF(NOT HAVE_DLFCN_H OR NOT HAVE_LIBDL)
    PKG_CHECK_MODULES(OPENAL openal)
ENDIF(WIN32)

IF(NOT OPENAL_FOUND)
    FIND_PACKAGE(OpenAL)
    IF(NOT OPENAL_FOUND)
        MESSAGE(FATAL_ERROR "OpenAL not found!\nPlease try setting the OPENALDIR environment variable and try again.")
    ENDIF(NOT OPENAL_FOUND)

    MESSAGE(STATUS "OpenAL include: ${OPENAL_INCLUDE_DIR}")
    MESSAGE(STATUS "OpenAL lib: ${OPENAL_LIBRARY}")

    INCLUDE_DIRECTORIES(${OPENAL_INCLUDE_DIR})
    SET(OPENAL_LIBRARIES ${OPENAL_LIBRARY})
ELSE(NOT OPENAL_FOUND)
    INCLUDE_DIRECTORIES(${OPENAL_INCLUDE_DIRS})
    LINK_DIRECTORIES(${OPENAL_LIBRARY_DIRS})
ENDIF(NOT OPENAL_FOUND)

# Base source files
SET(ALURE_OBJS  src/alure.cpp
                src/buffer.cpp
                src/istream.cpp
                src/stream.cpp
                src/streamdec.cpp
                src/streamplay.cpp
                src/codec_wav.cpp
                src/codec_aiff.cpp
)

# SndFile support
IF(SNDFILE)
    PKG_CHECK_MODULES(SNDFILE sndfile)
    IF(SNDFILE_FOUND)
        SET(HAS_SNDFILE 1)
        LINK_DIRECTORIES(${SNDFILE_LIBRARY_DIRS})
        SET_SOURCE_FILES_PROPERTIES(src/codec_sndfile.cpp PROPERTIES
                                    COMPILE_FLAGS "${SNDFILE_CFLAGS}")
    ELSE(SNDFILE_FOUND)
        FIND_PACKAGE(SndFile)
        IF(SNDFILE_FOUND)
            SET(HAS_SNDFILE 1)
            INCLUDE_DIRECTORIES(${SNDFILE_INCLUDE_DIRS})
        ENDIF(SNDFILE_FOUND)
    ENDIF(SNDFILE_FOUND)
    IF(HAS_SNDFILE)
        SET(ALURE_OBJS ${ALURE_OBJS} src/codec_sndfile.cpp)
    ENDIF(HAS_SNDFILE)
ELSE(SNDFILE)
    SET(SNDFILE_LIBRARIES "")
ENDIF(SNDFILE)

# Vorbis support
IF(VORBIS)
    PKG_CHECK_MODULES(VORBISFILE vorbisfile)
    IF(VORBISFILE_FOUND)
        SET(HAS_VORBISFILE 1)
        LINK_DIRECTORIES(${VORBISFILE_LIBRARY_DIRS})
        SET_SOURCE_FILES_PROPERTIES(src/codec_vorbisfile.cpp PROPERTIES
                                    COMPILE_FLAGS "${VORBISFILE_CFLAGS}")
    ELSE(VORBISFILE_FOUND)
        FIND_PACKAGE(OggVorbis)
        IF(OGGVORBIS_FOUND)
            SET(HAS_VORBISFILE 1)
            INCLUDE_DIRECTORIES(${OGGVORBIS_INCLUDE_DIRS})
            SET(VORBISFILE_LIBRARIES ${OGGVORBIS_LIBRARIES})
        ENDIF(OGGVORBIS_FOUND)
    ENDIF(VORBISFILE_FOUND)
    IF(NOT HAS_VORBISFILE)
        PKG_CHECK_MODULES(VORBISIDEC vorbisidec)
        IF(NOT VORBISIDEC_FOUND)
            CHECK_INCLUDE_FILE(tremor/ivorbisfile.h HAVE_TREMOR_IVORBISFILE_H)
            IF(HAVE_TREMOR_IVORBISFILE_H)
                CHECK_SHARED_FUNCTION_EXISTS(ov_open "tremor/ivorbisfile.h" vorbisidec "" HAVE_LIBVORBISIDEC)
                IF(DYNLOAD OR HAVE_LIBVORBISIDEC)
                    SET(HAS_VORBISFILE 1)
                    IF(HAVE_LIBVORBISIDEC)
                        SET(VORBISFILE_LIBRARIES "vorbisidec")
                    ENDIF(HAVE_LIBVORBISIDEC)
                    SET_SOURCE_FILES_PROPERTIES(src/codec_vorbisfile.cpp PROPERTIES
                                                COMPILE_FLAGS "-DHAS_VORBISIDEC")
                ENDIF(DYNLOAD OR HAVE_LIBVORBISIDEC)
            ENDIF(HAVE_TREMOR_IVORBISFILE_H)
        ELSE(NOT VORBISIDEC_FOUND)
            SET(HAS_VORBISFILE 1)
            LINK_DIRECTORIES(${VORBISIDEC_LIBRARY_DIRS})
            SET_SOURCE_FILES_PROPERTIES(src/codec_vorbisfile.cpp PROPERTIES
                                        COMPILE_FLAGS "${VORBISIDEC_CFLAGS} -DHAS_VORBISIDEC")
        ENDIF(NOT VORBISIDEC_FOUND)
    ENDIF(NOT HAS_VORBISFILE)
    IF(HAS_VORBISFILE)
        SET(ALURE_OBJS ${ALURE_OBJS} src/codec_vorbisfile.cpp)
    ENDIF(HAS_VORBISFILE)
ELSE(VORBIS)
    SET(VORBISFILE_LIBRARIES "")
ENDIF(VORBIS)

# FLAC support
IF(FLAC)
    FIND_PACKAGE(FLAC)
    IF(FLAC_FOUND)
        INCLUDE_DIRECTORIES(${FLAC_INCLUDE_DIR})
        SET(HAS_FLAC 1)
    ENDIF(FLAC_FOUND)
    IF(HAS_FLAC)
        SET(ALURE_OBJS ${ALURE_OBJS} src/codec_flac.cpp)
    ENDIF(HAS_FLAC)
ELSE(FLAC)
    SET(LIBFLAC_LIBRARIES "")
ENDIF(FLAC)

# MPG123 support
IF(MPG123)
    PKG_CHECK_MODULES(MPG123 libmpg123)
    IF(NOT MPG123_FOUND)
        CHECK_INCLUDE_FILE(mpg123.h HAVE_MPG123_H)
        IF(HAVE_MPG123_H)
            CHECK_SHARED_FUNCTION_EXISTS(mpg123_init "mpg123.h" mpg123 "" HAVE_LIBMPG123)
            IF(DYNLOAD OR HAVE_LIBMPG123)
                SET(HAS_MPG123 1)
                IF(HAVE_LIBMPG123)
                    SET(MPG123_LIBRARIES "mpg123")
                ENDIF(HAVE_LIBMPG123)
            ENDIF(DYNLOAD OR HAVE_LIBMPG123)
        ENDIF(HAVE_MPG123_H)
    ELSE(NOT MPG123_FOUND)
        SET(HAS_MPG123 1)
        LINK_DIRECTORIES(${MPG123_LIBRARY_DIRS})
        SET_SOURCE_FILES_PROPERTIES(src/codec_mpg123.cpp PROPERTIES
                                    COMPILE_FLAGS "${MPG123_CFLAGS}")
    ENDIF(NOT MPG123_FOUND)
    IF(HAS_MPG123)
        SET(ALURE_OBJS ${ALURE_OBJS} src/codec_mpg123.cpp)
    ENDIF(HAS_MPG123)
ELSE(MPG123)
    SET(MPG123_LIBRARIES "")
ENDIF(MPG123)

# DUMB support
IF(DUMB)
    CHECK_INCLUDE_FILE(dumb.h HAVE_DUMB_H)
    IF(HAVE_DUMB_H)
        IF(HAS_LIBM)
            CHECK_LIBRARY_EXISTS("dumb;m" dumbfile_open_ex "" HAVE_LIBDUMB)
        ELSE(HAS_LIBM)
            CHECK_LIBRARY_EXISTS(dumb dumbfile_open_ex "" HAVE_LIBDUMB)
        ENDIF(HAS_LIBM)
        IF(DYNLOAD OR HAVE_LIBDUMB)
            SET(HAS_DUMB 1)
            IF(HAVE_LIBDUMB)
                SET(DUMB_LIBRARIES dumb)
            ENDIF(HAVE_LIBDUMB)
        ENDIF(DYNLOAD OR HAVE_LIBDUMB)
    ENDIF(HAVE_DUMB_H)
    IF(HAS_DUMB)
        SET(ALURE_OBJS ${ALURE_OBJS} src/codec_dumb.cpp)
    ENDIF(HAS_DUMB)
ELSE(DUMB)
    SET(DUMB_LIBRARIES "")
ENDIF(DUMB)

# ModPlug support
IF(MODPLUG)
    CHECK_INCLUDE_FILE(libmodplug/modplug.h HAVE_LIBMODPLUG_MODPLUG_H)
    IF(HAVE_LIBMODPLUG_MODPLUG_H)
        CHECK_SHARED_FUNCTION_EXISTS(ModPlug_Load "libmodplug/modplug.h" modplug "" HAVE_LIBMODPLUG)
        IF(DYNLOAD OR HAVE_LIBMODPLUG)
            SET(HAS_MODPLUG 1)
            IF(HAVE_LIBMODPLUG)
                SET(MODPLUG_LIBRARIES "modplug")
            ENDIF(HAVE_LIBMODPLUG)
        ENDIF(DYNLOAD OR HAVE_LIBMODPLUG)
    ENDIF(HAVE_LIBMODPLUG_MODPLUG_H)
    IF(HAS_MODPLUG)

=== debian/changelog ===
alure (1.2-11) unstable; urgency=medium

  * Team upload
  * Drop Homepage which does no longer exist
  * Drop libsndfile support
  * Override min cmake version (Closes: #1112696)

 -- Bastian Germann <bage@debian.org>  Thu, 16 Oct 2025 13:01:15 +0200

alure (1.2-10) unstable; urgency=medium

  * Team upload
  * Set Rules-Requires-Root: no
  * Apply Multi-Arch: hint
  * Bump Standards-Version to 4.7.0

 -- Alexandre Detiste <tchet@debian.org>  Sat, 23 Nov 2024 13:51:19 +0100

alure (1.2-9) unstable; urgency=medium

  * Team upload
  * Disable fluidsynth (Closes: #1001303)

 -- Bastian Germann <bage@debian.org>  Thu, 23 Dec 2021 22:39:49 +0100

alure (1.2-8) unstable; urgency=medium

  * Team upload
  * New homepage (Closes: #980868)
  * Remove Andreas (MIA) from Uploaders (Closes: #743515)
  * Update to debhelper-compat v13
  * Make use of debhelper default
  * d/copyright: Add missing licenses
  * Make package lintian clean

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #888033)
    + Let dh_auto_configure pass cross flags to cmake.
    + Use a host $(CC) from buildtools.mk.

 -- Bastian Germann <bage@debian.org>  Sat, 23 Oct 2021 20:44:44 +0200

alure (1.2-7) unstable; urgency=low

  * Team upload

  [ Ansgar Burchardt ]
  * debian/control: Remove DM-Upload-Allowed.

  [ Bastian Germann ]
  * Disable DYNLOAD which causes problems (Closes: #960707)
  * Enable modplug without patch
  * Patch: Link FLAC correctly
  * Remove unneeded lintian overrides
  * debian/control: Set Vcs-* to salsa

 -- Bastian Germann <bastiangermann@fishpost.de>  Mon, 04 Jan 2021 03:08:34 +0100

alure (1.2-6) unstable; urgency=low

  * Fix build with GCC 4.7 by cherrypicking upstream commit
    38e56406f47ee1322464e67b8fea8822856af61b
    (Closes: #674383)

 -- Moritz Muehlenhoff <jmm@debian.org>  Sun, 27 May 2012 12:36:22 +0200

alure (1.2-5) unstable; urgency=low

  * Change Depends on dlopened libraries to Recommends.
    This uses different mechanism to generate Recommends. (Closes: #669520)

 -- Andres Mejia <amejia@debian.org>  Sat, 05 May 2012 16:14:42 -0400

alure (1.2-4) unstable; urgency=low

  * Enable hardened compiler flags.

 -- Andres Mejia <amejia@debian.org>  Mon, 19 Mar 2012 09:52:02 -0400

alure (1.2-3) unstable; urgency=low

  * Allow dev package to be multiarch installable.
  * Bump to Standards-Version 3.9.3.

 -- Andres Mejia <amejia@debian.org>  Fri, 16 Mar 2012 16:40:00 -0400

alure (1.2-2) unstable; urgency=low

  * Be slightly less strict on version build depends on debhelper.
  * Update Vcs-* entries.
  * Create new package to install utility programs.
  * Support parallel builds.
  * Use -O2 instead of -O3.
  * Make lintian override comment more descriptive.
  * Set option to abort on upstream changes.

 -- Andres Mejia <amejia@debian.org>  Sun, 25 Sep 2011 12:12:27 -0400

alure (1.2-1) unstable; urgency=low

  [ Andres Mejia ]
  * Update to my @debian.org email.
  * Add gbp.conf to add pristine-tar option on by default.
  * Get rid of unneccesary lintian overrides.
  * Add DEP-3 patch descriptions and refresh patches.

  [ Tobias Hansen ]
  * New upstream release.
  * Add multiarch support.
  * Add man pages for example programs.

 -- Andres Mejia <amejia@debian.org>  Mon, 01 Aug 2011 10:25:56 -0400

alure (1.1-3) unstable; urgency=low

  * Add linker version script to prevent
    unnecessary symbols from being exported.
  * Add symbols file. (Closes: #625248)
  * Link to libdumb.so.1 instead of libdumb.so

 -- Tobias Hansen <tobias.han@gmx.de>  Sat, 28 May 2011 17:30:12 +0200

alure (1.1-2) unstable; urgency=low

  * Remove shlibs file. Dependency on libalure need not be so strict.

 -- Andres Mejia <mcitadel@gmail.com>  Fri, 22 Apr 2011 18:56:24 -0400

alure (1.1-1) unstable; urgency=low

  [ Tobias Hansen ]
  * Add shlibs file.
  * Add copyright information for Debian packaging.
  * Delete lintian-overrides for dbg package.
  * Unapply patches after build

  [ Andres Mejia ]
  * Enable modplug support without sndfile.h conflict.
  * Include dependencies for dynamically loaded libraries.
  * Build libalure for release. Removes debugging package.
  * Use compiler flags changes from openal-soft.
  * Bump Standards-Version to 3.9.2.

 -- Andres Mejia <mcitadel@gmail.com>  Fri, 22 Apr 2011 18:15:53 -0400

alure (1.0-2) unstable; urgency=low

  * Added fix for 64-bit builds taken from upstream.
  * Bump Standards-Version to 3.8.2.
  * Use DEB_CXXFLAGS instead of DEB_CFLAGS to override CXXFLAGS used.

 -- Andres Mejia <mcitadel@gmail.com>  Thu, 06 Aug 2009 22:02:13 -0400

alure (1.0-1) unstable; urgency=low

  * Initial release. (Closes: #532690)

 -- Andres Mejia <mcitadel@gmail.com>  Sat, 13 Jun 2009 17:30:05 -0400

=== debian/control ===
Source: alure
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Tobias Hansen <tobias.han@gmx.de>
Build-Depends: debhelper-compat (= 13), cmake, libopenal-dev,
 libvorbis-dev, libflac-dev, libmpg123-dev, libdumb1-dev,
 libmodplug-dev
Rules-Requires-Root: no
Standards-Version: 4.7.0
Section: libs
Vcs-Git: https://salsa.debian.org/games-team/alure.git
Vcs-Browser: https://salsa.debian.org/games-team/alure

Package: libalure-dev
Section: libdevel
Multi-Arch: same
Architecture: any
Depends: libopenal-dev, libalure1 (= ${binary:Version}), ${misc:Depends}
Suggests: alure-doc
Description: AL Utilities REtooled (development files)
 ALURE is a utility library to help manage common tasks with OpenAL
 applications. This includes device enumeration and initialization, file
 loading, and streaming.
 .
 The purpose of this library is to provide pre-made functionality that would
 otherwise be repetitive or difficult to (re)code for various projects and
 platforms, such as loading a sound file into an OpenAL buffer and streaming an
 audio file through a buffer queue. Support for different formats is consistent
 across platforms, so no special checks are needed when loading files, and all
 formats are handled through the same API.
 .
 Currently ALURE includes a basic .wav and .aif file reader, and can leverage
 external libraries such as libSndFile (for extended wave formats and several
 others), VorbisFile (for Ogg Vorbis), and FLAC (for FLAC and Ogg FLAC), and
 others. External libraries can also be dynamically loaded at run-time, or
 individually disabled outright at compile time.
 .
 This package contains the files necessary for development.

Package: libalure1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: AL Utilities REtooled (shared library)
 ALURE is a utility library to help manage common tasks with OpenAL
 applications. This includes device enumeration and initialization, file
 loading, and streaming.
 .
 The purpose of this library is to provide pre-made functionality that would
 otherwise be repetitive or difficult to (re)code for various projects and
 platforms, such as loading a sound file into an OpenAL buffer and streaming an
 audio file through a buffer queue. Support for different formats is consistent
 across platforms, so no special checks are needed when loading files, and all
 formats are handled through the same API.
 .
 Currently ALURE includes a basic .wav and .aif file reader, and can leverage
 external libraries such as libSndFile (for extended wave formats and several
 others), VorbisFile (for Ogg Vorbis), and FLAC (for FLAC and Ogg FLAC), and
 others. External libraries can also be dynamically loaded at run-time, or
 individually disabled outright at compile time.
 .
 This package installs the ALURE shared library.

Package: alure-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: AL Utilities REtooled (documentation)
 ALURE is a utility library to help manage common tasks with OpenAL
 applications. This includes device enumeration and initialization, file
 loading, and streaming.
 .
 The purpose of this library is to provide pre-made functionality that would
 otherwise be repetitive or difficult to (re)code for various projects and
 platforms, such as loading a sound file into an OpenAL buffer and streaming an
 audio file through a buffer queue. Support for different formats is consistent
 across platforms, so no special checks are needed when loading files, and all
 formats are handled through the same API.
 .
 Currently ALURE includes a basic .wav and .aif file reader, and can leverage
 external libraries such as libSndFile (for extended wave formats and several
 others), VorbisFile (for Ogg Vorbis), and FLAC (for FLAC and Ogg FLAC), and
 others. External libraries can also be dynamically loaded at run-time, or
 individually disabled outright at compile time.
 .
 This package installs the ALURE documentation.

Package: alure-utils
Section: utils
Architecture: any
Depends: libalure1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Replaces: libalure-dev (<< 1.2-2)
Breaks: libalure-dev (<< 1.2-2)
Description: AL Utilities REtooled (utilities)
 ALURE is a utility library to help manage common tasks with OpenAL
 applications. This includes device enumeration and initialization, file
 loading, and streaming.
 .
 The purpose of this library is to provide pre-made functionality that would
 otherwise be repetitive or difficult to (re)code for various projects and
 platforms, such as loading a sound file into an OpenAL buffer and streaming an
 audio file through a buffer queue. Support for different formats is consistent
 across platforms, so no special checks are needed when loading files, and all
 formats are handled through the same API.
 .
 Currently ALURE includes a basic .wav and .aif file reader, and can leverage
 external libraries such as libSndFile (for extended wave formats and several
 others), VorbisFile (for Ogg Vorbis), and FLAC (for FLAC and Ogg FLAC), and
 others. External libraries can also be dynamically loaded at run-time, or
 individually disabled outright at compile time.
 .
 This package installs the various ALURE utility programs.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk
-include /usr/share/dpkg/buildtools.mk

# Use this variable to allow options passed to cmake to be overridable
DEB_CMAKE_OPTIONS ?= \
		-DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
		-DDYNLOAD=OFF \
		-DMODPLUG=ON \
		-DSNDFILE=OFF \
		-DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)"

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CMAKE_OPTIONS)

override_dh_shlibdeps: debian/tmp/alure-dummy.so
	dh_shlibdeps -O--parallel

debian/tmp/alure-dummy.so:
	mkdir -p debian/tmp
	$(CC) -xc -shared -Wl,--no-as-needed -Wl,-z,relro -Wl,-z,now -o $@ /dev/null \
		-lvorbisfile \
		-lFLAC \
		-lmpg123 \
		-ldumb \
		-lmodplug

=== debian/watch ===
version=4

opts=uversionmangle=s/\.(tar.*|tgz|zip|gz|bz2)$//i,dversionmangle=s/[-.+~]?(cvs|svn|git|snapshot|pre|hg)(.*)$//i,pasv \
https://kcat.tomasu.net/alure.html alure-releases/alure-?_?([\d+\.]+|\d+)\.tar\.bz2 debian uupdate
